Projet

Général

Profil

Gopher » Historique » Version 2

« Précédent - Version 2/3 (diff) - Version actuelle
Fabien Dupont, 12/06/2013 11:31


Installation d'un serveur gopher

Gopher ?

Gopher, c'est lui :

Mais ce n'est pas ce qui nous intéresse actuellement sauf si un fan de « La croisière s'amuse » tombe sur cette page.

Gopher, c'est avant tout (je cite wikipedia) : « un monde parallèle à celui du Web (et créé à la même époque que ce dernier). ». C'est pas du web mais c'est de l'Internet, donc pourquoi pas faire ça chez Tetaneutral.net ?

C'est une sorte d'accès à des fichiers listés par une sorte d'index, la « gophermap ». C'est du simple, du minimaliste, mais ça fonctionne bien depuis des années.

Installation du daemon gopher.

Le daemon

Il existe plusieurs implémentations de gopher, j'ai choisi gophrier car le nom est rigolo (c'est vraiment le seul argument).

# apt-get install build-essentials cmake
# cd /usr/local/src
# wget http://download.tuxfamily.org/gophrier/gophrier-0.2.3.tar.gz
# tar xvf gophrier-0.2.3.tar.gz
# cd gophrier-0.2.3.tar.gz
# cmake .
# make
# cp gophrier /usr/local/bin

La configuration

Gophrier a un système de configuration simple : des fichiers dans un répertoire contenant une seule ligne.

# mkdir -p /etc/gophrier/gophermap
# echo 1 > /etc/gophrier/ipv6
# mkdir /var/log/gophrier
# echo /var/log/gophrier > /etc/gophrier/logdir
# echo /var/run/gophier.pid > /etc/gophrier/pidpath
# mkdir /var/gopher
# echo /var/gopher > /etc/gophrier/rootdir
# echo 1 > /etc/gophrier/gophermap/enable

Le script de démarrage

Lui, je l'ai fait à partir de /etc/init.d/skel et c'est donc /etc/init.d/gophrier

#! /bin/sh
### BEGIN INIT INFO
# Provides:          skeleton
# Required-Start:    $remote_fs $syslog
# Required-Stop:     $remote_fs $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Example initscript
# Description:       This file should be used to construct scripts to be
#                    placed in /etc/init.d.
### END INIT INFO

# Author: Foo Bar <foobar@baz.org>
#
# Please remove the "Author" lines above and replace them
# with your own name if you copy and modify this script.

# Do NOT "set -e" 

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin:/usr/local/bin
DESC="Gopher server" 
NAME=gophrier
DAEMON=/usr/local/bin/$NAME
DAEMON_ARGS="-c /etc/gophrier" 
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
        # Return
        #   0 if daemon has been started
        #   1 if daemon was already running
        #   2 if daemon could not be started
        start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
                || return 1
        start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
                $DAEMON_ARGS \
                || return 2
        # Add code here, if necessary, that waits for the process to be ready
        # to handle requests from services started subsequently which depend
        # on this one.  As a last resort, sleep for some time.
}

#
# Function that stops the daemon/service
#
do_stop()
{
        # Return
        #   0 if daemon has been stopped
        #   1 if daemon was already stopped
        #   2 if daemon could not be stopped
        #   other if a failure occurred
        start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
        RETVAL="$?" 
        [ "$RETVAL" = 2 ] && return 2
        # Wait for children to finish too if this is a daemon that forks
        # and if the daemon is only ever run from this initscript.
        # If the above conditions are not satisfied then add some other code
        # that waits for the process to drop all resources that could be
        # needed by services started subsequently.  A last resort is to
        # sleep for some time.
        start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
        [ "$?" = 2 ] && return 2
        # Many daemons don't delete their pidfiles when they exit.
        rm -f $PIDFILE
        return "$RETVAL" 
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
        #
        # If the daemon can reload its configuration without
        # restarting (for example, when it is sent a SIGHUP),
        # then implement that here.
        #
        start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
        return 0
}

case "$1" in
  start)
        [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME" 
        do_start
        case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
  stop)
        [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME" 
        do_stop
        case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
  status)
       status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
       ;;
  #reload|force-reload)
        #
        # If do_reload() is not implemented then leave this commented out
        # and leave 'force-reload' as an alias for 'restart'.
        #
        #log_daemon_msg "Reloading $DESC" "$NAME" 
        #do_reload
        #log_end_msg $?
        #;;
  restart|force-reload)
        #
        # If the "reload" option is implemented then remove the
        # 'force-reload' alias
        #
        log_daemon_msg "Restarting $DESC" "$NAME" 
        do_stop
        case "$?" in
          0|1)
                do_start
                case "$?" in
                        0) log_end_msg 0 ;;
                        1) log_end_msg 1 ;; # Old process is still running
                        *) log_end_msg 1 ;; # Failed to start
                esac
                ;;
          *)
                # Failed to stop
                log_end_msg 1
                ;;
        esac
        ;;
  *)
        #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
        echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
        exit 3
        ;;
esac

:

Il faut bien sûr l'activer au démarrage de la machine.

# update-rc.d gophrier defaults

Quick and dirty HTML to gopher

Vu que j'avais la flemme d'écrire le site tetaneutral.net à la main en texte, j'ai fait un script môche de conversion (/usr/local/bin/html2gopher.pl) :

#!/usr/bin/env perl

use strict;
use utf8;
use Text::Unidecode;

my $url = "http://www.tetaneutral.net/";
my $site = "tetaneutral.net";
my $port = 70;
my $dest = "/var/gopher";
my $map = "$dest/gophermap";

my $cat;

system "rm -f $dest/*";
open(MAP, ">$map");
open(DUMP, "elinks -dump -no-numbering -no-references -dump-charset iso-8859-1 -default-mime-type text/html $url |");
while(<DUMP>)
{
        s/\n$//;
        if(/^[^ ]/)
        {
                $cat = unidecode($_);
                if($cat)
                {
                        close DEST;
                        print MAP "0$cat        ";
                        $cat =~ s/( |')/_/g;
                        print MAP "$cat.txt     $site   $port\n";
                }
                open(DEST, ">$dest/$cat.txt");
        }

        if($cat)
        {
                print DEST "$_\n";
        }
}

close DEST;
close MAP;

Concrêtement, ce script dumpe http://www.tetaneutral.net/, extrait les catégories, en fait des fichiers textes et créé la gophermap du site gopher.

Il est exécuté via crontab, une fois par heure, pour suivre les mises à jour du site.

# Generation du site gopher (http://chiliproject.tetaneutral.net/projects/tetaneutral/wiki/Gopher)
0 * * * * /usr/local/bin/html2gopher.pl

Accès au site en gopher

Dans un terminal, lynx ou elinks

# elinks gopher://tetaneutral.net/
                                                                                                            Gopher Menu
                                                      Gopher Menu

(FILE) Contact
(FILE) Campagne d'adhesion
(FILE) Actualites
(FILE) Le projet
(FILE) Participer
(FILE) Transparence
(FILE) Services
(FILE) Neutralite du reseau
(FILE) Fournir un acces a internet
(FILE) Hebergeur internet
(FILE) Operateur
(FILE) Partenaires
(FILE) Les moyens techniques
(FILE) Historique du projet
(FILE) Actualites passees
(FILE) Administratif

Commands: Use arrow keys to move, '?' for help, 'q' to quit, '<-' to go back.
  Arrow keys: Up and Down to move.  Right to follow a link; Left to go back.
 H)elp O)ptions P)rint G)o M)ain screen Q)uit /=search [delete]=history list

Dans firefox ou android

Je cite alarig dans IRC :

alarig │ Il existe aussi https://addons.mozilla.org/fr/firefox/addon/overbiteff/
alarig │ Tu peux lire du gopher dans firefox avec ça

http://gopher.floodgap.com/overbite/ pour plus d'informations.